//-------------------------------------------------------------------------------------
//	dummy_12ax7_v04.h
//-------------------------------------------------------------------------------------

//-------------------------------------------------------------------------------------
//	Phil le   26/01/2013  
//-------------------------------------------------------------------------------------







//-------------------------------------------------------------------------------------
#ifndef base_h
#define base_h
//-------------------------------------------------------------------------------------

//-------------------------------------------------------------------------------------
//	definitions et constantes
//-------------------------------------------------------------------------------------

#define F_CPU 			16000000UL		//frequence quartz

#define SET_NUL 		0   //commande nulle
#define SET_STOP 		1   //commande arret

#define SET_VA_max 		2   //VA_max
#define SET_VG2_max 	3   //VG2_max
#define SET_VG1_max 	4   //VG1_max
#define SET_VFIL_max 	5   //VFIL_max
#define SET_IA_max 		6   //IA_max
#define SET_IG2_max 	7   //IG2_max
#define SET_IG1_max 	8   //IG1_max
#define SET_PWA_max 	9   //PWA_max
#define SET_PWG2_max 	10  //PWG2_max
#define SET_PWG1_max 	11  //PWG1_max

#define SET_VG2_min 	12   //VG2_min
#define SET_VG1_min 	13   //VG1_min
#define SET_VFIL_min 	14   //VFIL_min

#define SET_VA 			15   //VA
#define SET_VG2 		16   //VG2
#define SET_VG1 		17   //VG1
#define SET_VFIL 		18   //VFIL

#define MESURE 			19   //MESURE


#define ncom 			20		//nombre de commandes possibles

#define mes_VA			1		//canal ADC de mesure
#define mes_VG1			2		//canal ADC de mesure
#define mes_VG2			3		//canal ADC de mesure
#define mes_IA			4		//canal ADC de mesure
#define mes_IG1			5		//canal ADC de mesure
#define mes_IG2			6		//canal ADC de mesure
#define mes_VFIL		7		//canal ADC de mesure

#define reg_VA			1		//port pour regler la tension
#define reg_VG1			2		//port pour regler la tension
#define reg_VG2			3		//port pour regler la tension
#define reg_VFIL		4		//port pour regler la tension

//-------------------------------------------------------------------------------------
//includes
//-------------------------------------------------------------------------------------

#include <avr/io.h>
#include</home/phil/ATMEL/atmel/avr/include/util/delay.h>
//#include</home/phil/ATMEL/atmel/avr/include/util/twi.h>
#include</home/phil/ATMEL/atmel/avr/include/avr/interrupt.h>
//#include</home/phil/ATMEL/avr-libc-1.4.4/doc/examples/demo/iocompat.h>
#include</home/phil/ATMEL/avr-libc-1.4.4/include/math.h>
#include</home/phil/ATMEL/avr-libc-1.4.4/include/string.h>

//-------------------------------------------------------------------------------------
//variables globales
//-------------------------------------------------------------------------------------

//tableau de pointeur de fonctions
void (*pf[ncom])(float);

//VA_max 
volatile float VA_max;

//VG2_max 
volatile float VG2_max;

//VG1_max 
volatile float VG1_max;

//VFIL_max 
volatile float VFIL_max;

//IA_max 
volatile float IA_max;

//IG2_max 
volatile float IG2_max;

//IG1_max 
volatile float IG1_max;

//PWA_max 
volatile float PWA_max;

//PWG2_max 
volatile float PWG2_max;

//PWG1_max 
volatile float PWG1_max;

//VG2_min 
volatile float VG2_min;

//VG1_min 
volatile float VG1_min;

//VFIL_min 
volatile float VFIL_min;

//VA 
volatile float VA;

//VG2 
volatile float VG2;

//VG1 
volatile float VG1;

//VFIL 
volatile float VFIL;

//attente
volatile uint8_t attente;

//afficheur
volatile uint8_t afficheur;

//sens
volatile uint8_t sens;

//valeur flottante
volatile float valeur_flottante;

//message
//volatile char mess[50];
char mess[50];

//-------------------------------------------------------------------------------------
//routines
//-------------------------------------------------------------------------------------

//main
int main(void);

//courant du tube 12ax7
uint8_t courant(float va,float vg,float *ia);

void fonc_void(float v);

void set_VA_max(float v);
void set_VG2_max(float v);
void set_VG1_max(float v);
void set_VFIL_max(float v);
void set_IA_max(float v);
void set_IG2_max(float v);
void set_IG1_max(float v);
void set_PWA_max(float v);
void set_PWG2_max(float v);
void set_PWG1_max(float v);
void set_VG2_min(float v);
void set_VG1_min(float v);
void set_VFIL_min(float v);

void set_VA(float v);
void set_VG2(float v);
void set_VG1(float v);
void set_VFIL(float v);

void mesure(float v);

void arret(float v);


void chenille(void);

void delai(uint16_t d);

//trace_ent
void trace_ent(int v,int s);

//trace_dec
void trace_dec(int v,int nd);

//initialisation transmission rs232
void rs232_init(unsigned char baud,unsigned char isr_rx);

//reception
unsigned char rs232_rx_8(void);

//emission
void rs232_tx_8(unsigned char v);

//emission d'une valeur quelconque
void rs232_tx_valeur(float v,int nd);

//reception d'une valeur quelconque
uint8_t rs232_rx_valeur(void);

//-------------------------------------------------------------------------------------
#endif
//-------------------------------------------------------------------------------------
