//-----------------------------------------------------------------------
//	main.cpp
//-----------------------------------------------------------------------
#include<iostream>
#include<stdio.h>
#include<string.h>
#include<termios.h>
#include<fcntl.h>
#include<unistd.h>
#include<stdlib.h>
#include<math.h>
//-----------------------------------------------------------------------
#define classe_e 
#include<main.h>
#undef classe_e

#define classe_e extern
#include<commun.h>
#undef classe_e

#define classe_e extern
#include<specifique.h>
#undef classe_e

using namespace std;
//-----------------------------------------------------------------------

FILE *flog;

//-----------------------------------------------------------------------
int main(void)
{
	system("clear");
	
	init();

	debut();
		
	action();

	fin();
			
	return 0;
}
//-----------------------------------------------------------------------
//init
void init(void)
{
}
//-----------------------------------------------------------------------
//fonction action
void action(void)
{
	FILE *f;
	FILE *ftdf;
	FILE *fcmde;
	int fd;
    struct termios options;
    
    //variables de controle
	float va;
	float vg1;
	float vg2;

	//variables mesurees
	float va_mes;
	float vg1_mes;
	float vg2_mes;
	float ia_mes;
	float ig1_mes;
	float ig2_mes;

	//variables min/max
	float va_max;
	float vg1_max;
	float vg2_max;
	float ia_max;
	float ig1_max;
	float ig2_max;
	float vfil_max;

	float vg1_min;
	float vg2_min;
	float vfil_min;

	float pwa_max;
	float pwg1_max;
	float pwg2_max;

	//code retour	
	int ret;

	//ouverture fichier resultat
	f=fopen("res.dat","w");
	verif(f,"creation fichier res impossible");

	//ouverture fichier resultat tdf
	ftdf=fopen("res.tdf","w");
	verif(ftdf,"creation fichier tdf impossible");

	//ouverture fichier log des commandes (hex)
	flog=fopen("res.log","w");
	verif(flog,"creation fichier log impossible");

	//ouverture fichier commande gnuplot
	fcmde=fopen("cmde","w");
	verif(fcmde,"creation fichier cmde impossible");


	//ouverture port serie (ttys0 pour le port com0 et ttys1 pour le port com1)
	fd = open("/dev/ttyS1", O_RDWR | O_NOCTTY | O_NDELAY);
    tcgetattr(fd, &options);
    cfmakeraw(&options);
	cfsetispeed(&options, B115200);
	cfsetospeed(&options, B115200);
    tcsetattr(fd, TCSANOW, &options);

	if (fd==-1)
	{
		cout<<"ouverture port serie /dev/ttyS1 impossible"<<endl;
	}
	else
	{
		fcntl(fd, F_SETFL, 0);
	}

	//bornes du domaine
	va_max=300;
	
	vg1_max=0;
	vg1_min=-50;

	vg2_max=0;
	vg2_min=0;

	ia_max=3.5;
	
	ig1_max=0;
	
	ig2_max=0;
	
	vfil_max=6.3*1.1;
	vfil_min=6.3*0.9;

	pwa_max=1;

	pwg1_max=0;

	pwg2_max=0;
	

	//envoi des valeurs limites au µtracer
	envoi_cmde(fd,SET_VA_max,va_max);

	envoi_cmde(fd,SET_VG1_max,vg1_max);
	envoi_cmde(fd,SET_VG1_min,vg1_min);

	envoi_cmde(fd,SET_VG2_max,vg2_max);
	envoi_cmde(fd,SET_VG2_min,vg2_min);

	envoi_cmde(fd,SET_VFIL_max,vfil_max);
	envoi_cmde(fd,SET_VFIL_min,vfil_min);

	envoi_cmde(fd,SET_IA_max,ia_max);
	envoi_cmde(fd,SET_IG1_max,ig1_max);
	envoi_cmde(fd,SET_IG2_max,ig2_max);

	envoi_cmde(fd,SET_PWA_max,pwa_max);
	envoi_cmde(fd,SET_PWG2_max,pwg2_max);
	envoi_cmde(fd,SET_PWG1_max,pwg1_max);

	//programmation de la tension de chauffage
	envoi_cmde(fd,SET_VFIL,6.3);


	//exploration parametrique
	while (true)
	{
		//boucle sur vg1
		for (vg1=vg1_min;vg1<=vg1_max;vg1=vg1+0.2)
		{
			//boucle sur va
			for (va=0;va<va_max;va=va+5)
			{

				//interrogation du µC
				ret=mesure(fd,1,va,0,vg1,&va_mes,&vg2_mes,&vg1_mes,&ia_mes,&ig2_mes,&ig1_mes);
				
				//passage de mA en A
				ia_mes=ia_mes/1000;
				ig1_mes=ig1_mes/1000;
				ig2_mes=ig2_mes/1000;

//				printf("va vg1 %f %f\n",va,vg1);

				//si pas de limitations renvoyée par le µC
				if (ret==0)
				{
					//ecriture de res.dat
					fprintf
							(
								f,
								"%f %f %f %f %f %f \n",
								va_mes,ia_mes*1000,
								vg1_mes,ig1_mes*1000,
								vg2_mes,ig2_mes*1000
							);				

					//ecriture de res.tdf
					fprintf
							(
								ftdf,
								"%f %f %f %f %f %f \n",
								va_mes,ia_mes,
								vg1_mes,ig1_mes,
								vg2_mes,ig2_mes
							);				

					//ecriture à l'ecran
					fprintf
							(
								stdout,
								"%7.3f %7.3f %7.3f %7.6f %7.6f %7.6f\n",
								va_mes,vg2_mes,vg1_mes,
								ia_mes*1000,ig2_mes,ig1_mes
							);				
				}
				
				
				//en cas de limitation
				if (ret!=0)
				{
					printf("limitation: code retour ---> %d\n",ret);
					
					fprintf(f,"\n");
				}
				
				//getchar();

			}
			
			fprintf(f,"\n");
		}
		
		break;
	}


	envoi_cmde(fd,SET_STOP,0);
	
	
	//exploitation des resultats
	

	fclose(f);
	fclose(ftdf);
	fclose(flog);
	fclose(fcmde);
	close(fd);
}


//-----------------------------------------------------------------------
//mesure
//-----------------------------------------------------------------------
int mesure	(	int fd,
				int nmes,
				float _va,
				float _vg2,
				float _vg1,
				float *va_mes,
				float *vg2_mes,
				float *vg1_mes,
				float *ia_mes,
				float *ig2_mes,
				float *ig1_mes
			)
{
	float ia;
	float ig1;
	float ig2;
	float va;
	float vg1;
	float vg2;
	float nmoy;		//nombre de moyennes
	int ret;		//code retour
	
	//nombre de moyennes
	nmoy=(float)nmes;
	
	//on regle les tensions
	envoi_cmde(fd,SET_VA,_va);
	envoi_cmde(fd,SET_VG2,_vg2);
	envoi_cmde(fd,SET_VG1,_vg1);
	
	//on fait la mesure
	ret=envoi_cmde(fd,MESURE,nmoy);
	
	//on recupere les mesures
	rs232_rx_valeur(fd,&va);
	rs232_rx_valeur(fd,&vg2);
	rs232_rx_valeur(fd,&vg1);
	rs232_rx_valeur(fd,&ia);
	rs232_rx_valeur(fd,&ig2);
	rs232_rx_valeur(fd,&ig1);
	
	//on retourne les mesures
	*va_mes=va;
	*vg1_mes=vg1;
	*vg2_mes=vg2;
	*ia_mes=ia;
	*ig1_mes=ig1;
	*ig2_mes=ig2;
	
//	printf("mesure--------------------------\n");
//	printf("mesure: code retour = %d\n",ret);
//	printf("regalge: %f %f %f\n",_va,_vg2,_vg1);
//	printf("vecteur: %f %f %f %f %f %f\n",va,vg2,vg1,ia,ig2,ig1);
//	getchar();
	
	return ret;
}









//-----------------------------------------------------------------------
//routines d'emission et de reception sur la rs232
//-----------------------------------------------------------------------


//-----------------------------------------------------------------------
bool rs232_tx_8(int fd,unsigned char c)
{
	bool res;
	int ntx;
		
	res=true;
	
	//envoi de la valeur
    ntx=write(fd,&c,1);

   	if (ntx<0)
	{    
		res=false;
	}
	
	return res;
}
//-----------------------------------------------------------------------
bool rs232_rx_8(int fd,unsigned char *c)
{
	bool res;
	int nrx;
	
	res=true;
	
	//lecture de la valeur
	nrx=read(fd,c,1);
	
   	if (nrx<0)
	{    
		res=0;
	}

	return res;
}
//-----------------------------------------------------------------------
//emission valeur flottante
bool rs232_tx_valeur_float(int fd,float v)
{
	int i;
	int l;
	char mess[50];
	
	sprintf(mess,"%6.3f",v);
	
	//printf("envoi d'une valeur flottante %6.3f --> %s\n",v,mess);
	l=strlen(mess);
	
	for (i=0;i<l;i++)
	{
		if (mess[i]==32)
		{
			mess[i]=48;
		}
		
		rs232_tx_8(fd,mess[i]);
		//printf("emi %d --->  %d %c\n",i,mess[i],mess[i]);
	}
	
	rs232_tx_8(fd,10);
	
	return 0;
}
//-----------------------------------------------------------------------
//emission valeur entiere
bool rs232_tx_valeur_int(int fd,int v)
{
	int i;
	int l;
	char mess[50];
	
	sprintf(mess,"%d",v);
	l=strlen(mess);
	
	for (i=0;i<l;i++)
	{
		rs232_tx_8(fd,mess[i]);
	}
	
	rs232_tx_8(fd,10);
	
	return 0;
}
//-----------------------------------------------------------------------
//reception valeur
bool rs232_rx_valeur(int fd,float *v)
{
	int i;
	int l;
	char mess[50];
	bool suite;
	unsigned char c;
	bool res;
		
	suite=1;
	l=0;

	//printf("reception\n");
		
	while (suite)
	{
		rs232_rx_8(fd,&c);
		mess[l]=(char)c;
		
	
		
		if (c==10)
		{
			mess[l]='\0';
			res=0;
			suite=0;
		}
		
		if (i>=49)
		{
			mess[l]='\0';
			res=1;
			suite=0;
		}
		
		l++;
	}
		
	
	*v=(float)atof(mess);	
//	printf("chaine = %s\n",mess);
//	printf("valeur = %f\n",*v);
		
	return res;
}
//-----------------------------------------------------------------------
//envoi commande
int envoi_cmde(int fd,int cmde,float v)
{
	int res;
	float recup;
	
	//envoi de la commande
	rs232_tx_valeur_int(fd,cmde);
	
	//envoi de la valeur
	rs232_tx_valeur_float(fd,v);
	
	//recup du retour
	rs232_rx_valeur(fd,&recup);

	res=(int)recup;

//	printf("envoi cmde %d valeur %f code retour %d\n",cmde,v,res);
	return res;
}


//-----------------------------------------------------------------------


